'use strict';


module.exports = function(def) {

  def.cli
    .command('login', '登录 DEF 客户端')
    .option('--app', 'the debug app', {'hide': true})
    .group('auth')
    .action(function* (opts) {
      def.log.info('[auth]', '正在登录...');
      const user = yield def.auth.user();
      def.log.info('[auth]', '%s，您已成功登录 DEF 客户端，祝您编码开心，生活愉快！',  user.nick);

      if (opts.app) {
        const ticket = yield def.auth.ticket({'app': opts.app});
        def.log.info('[auth]', 'ticket= %s', ticket);
      }
    });

  def.cli
    .command('logout', '登出 DEF 客户端')
    .group('auth')
    .action(function* () {
      def.log.info('[auth]', '正在退出登录...');
      yield def.auth.logout();
      def.log.info('[auth]', '您已成功登出 DEF 客户端');
    });

};