'use strict';

const co = require('co');
const Auth = require('./../auth');
const io = require('./../io');

const argv = process.argv.slice(2);
console.log('argv=', argv);

const server = argv[0];
const api = argv[1];
const tokenPath = argv[2];
const data = JSON.parse(argv[3]);

const auth = new Auth({
  'server': server,
  'tokenPath': tokenPath,
  'timeout': 60 * 1000
});

co(function* () {
  let user = null;
  try {
    user = yield auth.user({'silent': true});
  } catch(e) {}

  data['user_nick'] = data['rel_user'] = 'anonymous';
  if (user) {
    data['user_nick'] = data['rel_user'] = (user['nick'] || user['lastName'] || 'anonymous');
  }

  console.log('report data=', data);
  return yield io.post(server + api, data, {'timeout': 60 * 1000});
})
.then((res) => {
  console.log('report res=', res.body);
  process.exit(0);
})
.catch((e) => {
  console.log('report err=', e);
  process.exit(1);
});
