'use strict';

var path = require('path');

var less = require('less-middleware');
var xtemplate = require('kissy-xtemplate/middleware/');
var ejs = require('../middleware/ejs');
var jade = require('../middleware/jade');


// default
module.exports = function(app, options) {

  app.use(less(options.base, {
      debug: options.debug,
      dest: options.tmpDir
    },
    {
      paths: [path.join(options.base, 'src')]
    },
    {
      compress: false,
      sourceMap: true
    }
  ));

  app.use(ejs({
    src: options.base
  }));

  app.use(jade({
    src: options.base,
    dest: options.tmpDir,
    pretty: true
  }));

  app.use(xtemplate(options.base, {
    debug: options.debug,
    dest: options.tmpDir
  }));

};
