'use strict';


module.exports = function(def) {
  const Promise = require('bluebird');
  const co = require('co');

  const yo = {};

  yo.run = co.wrap(run.bind(yo));


  /**
   *
   * @param opts
   *   resolved:
   *   generator:
   *   name:
   *   argv:
   */
  function* run(opts) {
    opts = opts || {};
    def.log.verbose('[yo]', 'run with: ', opts);

    if (opts.resolved) {
      def.log.verbose('[yo]', 'resolved= %s', opts.resolved);
      yield G(opts.resolved, opts.argv);
      return;
    }

    /*
     * spec=
     *   xcake:page
     *   @ali/cake:page
     */
    let spec = (opts.generator || opts.name).split(':');

    let name = spec[0].replace(/^(generator-)?(.+)$/, 'generator-$2');
    let sub = spec[1] || 'app';

    yield def.checkUpdate(name, 'generator');

    let resolved = def.store.resolve(name + '/' + sub + '/index.js');
    if (!resolved) {
      resolved = def.store.resolve(name + '/generators/' + sub + '/index.js');
    }
    def.log.verbose('[yo]', 'resolved= %s', resolved);

    if (!resolved) {
      throw new Error('查找 generator `' + name + '` 失败.');
    }

    yield G(resolved, opts.argv || []);
  }

  function G(resolved, argv) {
    return new Promise(function(resolve, reject) {
      let Generator = require(resolved);
      let g = new Generator(argv, {
        'resolved': resolved,
        'env': {
          'cwd': process.cwd()
        }
      });

      g.run(function(err) {
        if (err) return reject(err);
        return resolve();
      });
    });
  }

  return yo;
};

