'use strict';

const debug = require('debug')('def:io');
const got = require('got');

const TIMEOUT = 1000;

module.exports = {

  'get': function(url, payload, config) {
    config = config || {};
    debug('get', url, payload, config);

    return this.got.get(url, {
      'json': true,
      'timeout': config.timeout || TIMEOUT,
      'retries': config.retries || 0,
      'query': payload || {}
    });
  },

  'post': function(url, payload, config) {
    config = config || {};
    debug('post', url, payload, config);

    return this.got.post(url, {
      'json': true,
      'timeout': config.timeout || TIMEOUT,
      'retries': config.retries || 0,
      'body': payload || {}
    });
  },

  'got': got
};